package org.powerscala

/**
 * @author Matt Hicks <mhicks@powerscala.org>
 */
sealed class Currency(val description: String) extends EnumEntry[Currency] {
  override def toString = "%s (%s)".format(description, name())
}

object Currency extends Enumerated[Currency] {
  val USD = new Currency("United States dollar")
  val CAD = new Currency("Canadian dollar")
  val EUR = new Currency("Euro")
  val GBP = new Currency("British pound")
  val AFN = new Currency("Afghan afghani")
  val ALL = new Currency("Albanian lek")
  val DZD = new Currency("Algerian dinar")
  val AOA = new Currency("Angolan kwanza")
  val ARS = new Currency("Argentine peso")
  val AMD = new Currency("Armenian dram")
  val AWG = new Currency("Aruban florin")
  val AUD = new Currency("Australian dollar")
  val AZN = new Currency("Azerbaijani manat")
  val BSD = new Currency("Bahamian dollar")
  val BHD = new Currency("Bahraini dinar")
  val BDT = new Currency("Bangladeshi taka")
  val BBD = new Currency("Barbadian dollar")
  val BYR = new Currency("Belarusian ruble")
  val BZD = new Currency("Belize dollar")
  val BMD = new Currency("Bermudian dollar")
  val BTN = new Currency("Bhutanese ngultrum")
  val BOB = new Currency("Bolivian boliviano")
  val BAM = new Currency("Bosnia and Herzegovina convertible mark")
  val BWP = new Currency("Botswana pula")
  val BRL = new Currency("Brazilian real")
  val BND = new Currency("Brunei dollar")
  val BGN = new Currency("Bulgarian lev")
  val MMK = new Currency("Burmese kyat")
  val BIF = new Currency("Burundian franc")
  val XPF = new Currency("CFP franc")
  val KHR = new Currency("Cambodian riel")
  val CVE = new Currency("Cape Verdean escudo")
  val KYD = new Currency("Cayman Islands dollar")
  val XAF = new Currency("Central African CFA franc")
  val CLP = new Currency("Chilean peso")
  val CNY = new Currency("Chinese yuan")
  val COP = new Currency("Colombian peso")
  val KMF = new Currency("Comorian franc")
  val CDF = new Currency("Congolese franc")
  val CRC = new Currency("Costa Rican colón")
  val HRK = new Currency("Croatian kuna")
  val CUC = new Currency("Cuban convertible peso")
  val CUP = new Currency("Cuban peso")
  val CZK = new Currency("Czech koruna")
  val DKK = new Currency("Danish krone")
  val DJF = new Currency("Djiboutian franc")
  val DOP = new Currency("Dominican peso")
  val XCD = new Currency("East Caribbean dollar")
  val EGP = new Currency("Egyptian pound")
  val ERN = new Currency("Eritrean nakfa")
  val ETB = new Currency("Ethiopian birr")
  val FKP = new Currency("Falkland Islands pound")
  val FJD = new Currency("Fijian dollar")
  val GMD = new Currency("Gambian dalasi")
  val GEL = new Currency("Georgian lari")
  val GHS = new Currency("Ghana cedi")
  val GIP = new Currency("Gibraltar pound")
  val GTQ = new Currency("Guatemalan quetzal")
  val GNF = new Currency("Guinean franc")
  val GYD = new Currency("Guyanese dollar")
  val HTG = new Currency("Haitian gourde")
  val HNL = new Currency("Honduran lempira")
  val HKD = new Currency("Hong Kong dollar")
  val HUF = new Currency("Hungarian forint")
  val ISK = new Currency("Icelandic króna")
  val INR = new Currency("Indian rupee")
  val IDR = new Currency("Indonesian rupiah")
  val IRR = new Currency("Iranian rial")
  val IQD = new Currency("Iraqi dinar")
  val ILS = new Currency("Israeli new shekel")
  val JMD = new Currency("Jamaican dollar")
  val JPY = new Currency("Japanese yen")
  val KZT = new Currency("Kazakhstani tenge")
  val KES = new Currency("Kenyan shilling")
  val KWD = new Currency("Kuwaiti dinar")
  val KGS = new Currency("Kyrgyzstani som")
  val LAK = new Currency("Lao kip")
  val LVL = new Currency("Latvian lats")
  val LBP = new Currency("Lebanese pound")
  val LSL = new Currency("Lesotho loti")
  val LRD = new Currency("Liberian dollar")
  val LYD = new Currency("Libyan dinar")
  val LTL = new Currency("Lithuanian litas")
  val MOP = new Currency("Macanese pataca")
  val MKD = new Currency("Macedonian denar")
  val MGA = new Currency("Malagasy ariary")
  val MWK = new Currency("Malawian kwacha")
  val MYR = new Currency("Malaysian ringgit")
  val MVR = new Currency("Maldivian rufiyaa")
  val MRO = new Currency("Mauritanian ouguiya")
  val MUR = new Currency("Mauritian rupee")
  val MXN = new Currency("Mexican peso")
  val MDL = new Currency("Moldovan leu")
  val MNT = new Currency("Mongolian tögrög")
  val MAD = new Currency("Moroccan dirham")
  val MZN = new Currency("Mozambican metical")
  val NAD = new Currency("Namibian dollar")
  val NPR = new Currency("Nepalese rupee")
  val ANG = new Currency("Netherlands Antillean guilder")
  val TWD = new Currency("New Taiwan dollar")
  val NZD = new Currency("New Zealand dollar")
  val NIO = new Currency("Nicaraguan córdoba")
  val NGN = new Currency("Nigerian naira")
  val KPW = new Currency("North Korean won")
  val NOK = new Currency("Norwegian krone")
  val OMR = new Currency("Omani rial")
  val PKR = new Currency("Pakistani rupee")
  val PAB = new Currency("Panamanian balboa")
  val PGK = new Currency("Papua New Guinean kina")
  val PYG = new Currency("Paraguayan guaraní")
  val PEN = new Currency("Peruvian nuevo sol")
  val PHP = new Currency("Philippine peso")
  val PLN = new Currency("Polish złoty")
  val QAR = new Currency("Qatari riyal")
  val RON = new Currency("Romanian leu")
  val RUB = new Currency("Russian ruble")
  val RWF = new Currency("Rwandan franc")
  val SHP = new Currency("Saint Helena pound")
  val SVC = new Currency("Salvadoran colón")
  val WST = new Currency("Samoan tālā")
  val SAR = new Currency("Saudi riyal")
  val RSD = new Currency("Serbian dinar")
  val SCR = new Currency("Seychellois rupee")
  val SLL = new Currency("Sierra Leonean leone")
  val SGD = new Currency("Singapore dollar")
  val SBD = new Currency("Solomon Islands dollar")
  val SOS = new Currency("Somali shilling")
  val ZAR = new Currency("South African rand")
  val KRW = new Currency("South Korean won")
  val SSP = new Currency("South Sudanese pound")
  val LKR = new Currency("Sri Lankan rupee")
  val SDG = new Currency("Sudanese pound")
  val SRD = new Currency("Surinamese dollar")
  val SZL = new Currency("Swazi lilangeni")
  val SEK = new Currency("Swedish krona")
  val CHF = new Currency("Swiss franc")
  val SYP = new Currency("Syrian pound")
  val STD = new Currency("São Tomé and Príncipe dobra")
  val TJS = new Currency("Tajikistani somoni")
  val TZS = new Currency("Tanzanian shilling")
  val THB = new Currency("Thai baht")
  val TOP = new Currency("Tongan paʻanga")
  val TTD = new Currency("Trinidad and Tobago dollar")
  val TND = new Currency("Tunisian dinar")
  val TRY = new Currency("Turkish lira")
  val TMT = new Currency("Turkmenistan manat")
  val UGX = new Currency("Ugandan shilling")
  val UAH = new Currency("Ukrainian hryvnia")
  val AED = new Currency("United Arab Emirates dirham")
  val UYU = new Currency("Uruguayan peso")
  val UZS = new Currency("Uzbekistani som")
  val VUV = new Currency("Vanuatu vatu")
  val VEF = new Currency("Venezuelan bolívar")
  val VND = new Currency("Vietnamese đồng")
  val XOF = new Currency("West African CFA franc")
  val YER = new Currency("Yemeni rial")
  val ZMK = new Currency("Zambian kwacha")
  val ZWL = new Currency("Zimbabwean dollar")
}